@echo off
rem --------------------------------------------------------------------------
rem	SCRIPT:	FFbuild.bat
rem	AUTHOR:	Ian Taylor - chilliant.com
rem	NOTES:	Flag Factory 16-bit build script
rem	--------------------------------------------------------------------------
setlocal
cd \Project\FF
path ..\NASM;..\DigitalMars\bin;..\UPX;%PATH%
del *.obj FF.com

set NASM=nasm.exe
set NASM_FLAGS=-Ox -oFF.obj -fobj
set NASM_FILES=FF.asm
echo %NASM_FILES%:
%NASM% %NASM_FLAGS% %NASM_FILES%

set DMC=dmc.exe
set DMC_FLAGS=-ff -mt -o+space -6 -NL -c
set DMC_FILES=FFcom.c FFcrt.c FFdata.c FFio.c FFmain.c FFsvg.c
%DMC% %DMC_FLAGS% %DMC_FILES%

set DML=link.exe
set DML_FLAGS=/OPT/NOD/NOI/DETAIL/TINY/ENTRY:STARTUP
set DML_FILES=FF+FFcom+FFcrt+FFdata+FFio+FFmain+FFsvg,FF.com,,,FF.def
%DML% %DML_FILES%%DML_FLAGS%;

echo ### Packing FF.com...
upx --ultra-brute FF.com

echo ### Running FF.com...
cd Test
rem ..\FF.com|cmd
rem ..\FF.com
rem ..\FF.com ff.html>ff.html
cd ..
echo ### Done.

rem   Digital Mars Compiler Version 8.42n
rem   Copyright (C) Digital Mars 2000-2004.  All Rights Reserved.
rem   Written by Walter Bright  www.digitalmars.com/ctg/sc.html
rem   DMC is a one-step program to compile and link C++, C and ASM files.
rem   Usage ([] means optional, ... means zero or more):
rem   
rem   	DMC file... [flags...] [@respfile] 
rem   
rem   file...		.CPP, .C or .ASM source, .OBJ object or .LIB library file name
rem   @respfile...	pick up arguments from response file or environment variable
rem   flags...	one of the following:
rem   -a[1|2|4|8] alignment of struct members	-A  strict ANSI C/C++
rem   -Aa enable new[] and delete[]		-Ab enable bool
rem   -Ae enable exception handling		-Ar enable RTTI
rem   -B[e|f|g|j] message language: English, French, German, Japanese
rem   -c  skip the link, do compile only	-cpp  source files are C++
rem   -cod  generate .cod (assembly) file	-C  no inline function expansion
rem   -d  generate .dep (make dependency) file
rem   -D  #define DEBUG 1			-Dmacro[=text]  define macro
rem   -e  show results of preprocessor	-EC do not elide comments
rem   -EL #line directives not output		-f  IEEE 754 inline 8087 code
rem   -fd work around FDIV problem		-ff fast inline 8087 code
rem   -g  generate debug info
rem   -gf disable debug info optimization	-gg make static functions global
rem   -gh symbol info for globals		-gl debug line numbers only
rem   -gp generate pointer validations	-gs debug symbol info only
rem   -gt generate trace prolog/epilog	-GTnnnn set data threshold to nnnn
rem   -H  use precompiled headers (ph)	-HDdirectory  use ph from directory
rem   -HF[filename]  generate ph to filename	-HHfilename  read ph from filename
rem   -HIfilename   #include "filename"	-HO include files only once
rem   -HS only search -I directories          -HX automatic precompiled headers
rem   
rem   -Ipath	#include file search path	-j[0|1|2]  Asian language characters
rem       0: Japanese 1: Taiwanese and Chinese 2: Korean
rem   -Jm relaxed type checking		-Ju char==unsigned char
rem   -Jb no empty base class optimization    -J  chars are unsigned
rem   -l[listfile]  generate list file	-L  using non-Digital Mars linker
rem   -Llink  specify linker to use		-L/switch  pass /switch to linker
rem   -Masm   specify assembler to use	-M/switch  pass /switch to assembler
rem   -m[tsmclvfnrpxz][do][w][u] set memory model
rem       s: small code and data		m: large code, small data
rem       c: small code, large data		l: large code and data
rem       v: VCM				r: Rational 16 bit DOS Extender
rem       p: Pharlap 32 bit DOS Extender	x: DOSX 32 bit DOS Extender
rem       z: ZPM 16 bit DOS Extender		f: OS/2 2.0 32 bit
rem       t: .COM file			n: Windows 32s/95/98/NT/2000/ME/XP
rem       d: DOS 16 bit			o: OS/2 16 bit
rem       w: SS != DS				u: reload DS
rem   -Nc function level linking		-NL no default library
rem   -Ns place expr strings in code seg	-NS new code seg for each function
rem   -NTname  set code segment name		-NV vtables in far data
rem   -o[-+flag]  run optimizer with flag	-ooutput  output filename
rem   -p  turn off autoprototyping		-P  default to pascal linkage
rem   -Pz default to stdcall linkage		-r  strict prototyping
rem   -R  put switch tables in code seg	-s  stack overflow checking
rem   -S  always generate stack frame		-u  suppress predefined macros
rem   -v[0|1|2] verbose compile		-w  suppress all warnings
rem   -wc warn on C style casts
rem   -wn suppress warning number n		-wx treat warnings as errors
rem   -W{0123ADabdefmrstuvwx-+}  Windows prolog/epilog
rem   	-WA  Windows EXE
rem   	-WD  Windows DLL
rem   -x  turn off error maximum		-XD instantiate templates
rem   -XItemp<type>  instantiate template class temp<type>
rem   -XIfunc(type)  instantiate template function func(type)
rem   -[0|2|3|4|5|6]  8088/286/386/486/Pentium/P6 code

rem   OPTLINK (R) for Win32  Release 8.00.5
rem   Copyright (C) Digital Mars 1989-2009  All rights reserved.
rem   A[lignment]               BAS[e]                    B[atch]
rem   BI[nary]                  BYO[rdinal]               CHECKA[bort]
rem   CHECKE[xe]                CHECKS[um]                CO[deview]
rem   COM[defsearch]            CP[armaxalloc]            CVV[ersion]
rem   CVW[arnings]              DEB[ug]                   DEBUGA[pploader]
rem   DEBUGB[rowser]            DEBUGC[overages]          DEBUGF[iles]
rem   DEBUGLI[nes]              DEBUGLO[cals]             DEBUGM[odules]
rem   DEBUGP[ublics]            DEBUGR[eferences]         DEBUGT[ypes]
rem   DEF[aultlibrarysearch]    DE[lexecutable]           DET[ailedmap]
rem   DO[sseg]                  EC[hoindirect]            EMSM[axsize]
rem   EMSP[ageframeio]          EMSU[se40]                EN[try]
rem   ER[rorflag]               E[xepack]                 EXET[ype]
rem   F[arcalltranslation]      FI[xds]                   FIXE[d]
rem   G[roupassociation]        GROUPS[tack]              HEA[p]
rem   H[elp]                    IG[norecase]              IMPD[ef]
rem   IMPL[ib]                  IMPLIBC[off]              I[nformation]
rem   L[inenumbers]             LO[wercase]               MAC[hine]
rem   M[ap]                     NOB[atch]                 NOCHECKA[bort]
rem   NOCHECKE[xe]              NOCHECKS[um]              NOCO[deview]
rem   NOCOM[defsearch]          NOCV[pack]                NODEB[ug]
rem   NODEBUGA[pploader]        NODEBUGB[rowser]          NODEBUGC[overages]
rem   NODEBUGLI[nes]            NODEBUGLO[cals]           NODEBUGP[ublics]
rem   NODEBUGR[eferences]       NODEBUGT[ypes]            NOD[efaultlibrarysearch]
rem   NODEL[executable]         NODET[ailedmap]           NODO[sseg]
rem   NOEC[hoindirect]          NOEMSP[ageframeio]        NOEMSU[se40]
rem   NOER[rorflag]             NOEXE[pack]               NOE[xtdictionary]
rem   NOF[arcalltranslation]    NOFI[xds]                 NOG[roupassociation]
rem   NOGROUPS[tack]            NOI[gnorecase]            NOLI[nenumbers]
rem   NOL[ogo]                  NOM[ap]                   NONA[mes]
rem   NONT[host]                NON[ullsdosseg]           NOP[ackcode]
rem   NOPACKD[ata]              NOPACKF[unctions]         NOPACKI[fnosegments]
rem   NOPAU[se]                 NOPR[ompt]                NOR[elocationcheck]
rem   NOREO[rdersegments]       NOSCANLIB                 NOSCANLINK
rem   NOWARND[ups]              NOWI[npack]               NOX[ref]
rem   NT[host]                  NU[llsdosseg]             ON[error]
rem   OPT                       PAC[kcode]                PACKD[ata]
rem   PACKF[unctions]           PACKI[fnosegments]        PACKS[ize]
rem   PADC[ode]                 PADD[ata]                 PAG[esize]
rem   PAU[se]                   PM[type]                  PR[ompt]
rem   RC                        RELOC[ationcheck]         REO[rdersegments]
rem   SCANLIB                   SCANLINK                  SE[gments]
rem   SEGP[ack]                 SI[lent]                  ST[ack]
rem   STU[b]                    SU[bsystem]               T[iny]
rem   U[ppercase]               VERS[ion]                 W[arnfixup]
rem   WARND[ups]                WI[npack]                 XM[smaxsize]
rem   X[ref]                    XN[oignorecase]           XU[ppercase]

rem   usage: ndisasm [-a] [-i] [-h] [-r] [-u] [-b bits] [-o origin] [-s sync...]
rem                  [-e bytes] [-k start,bytes] [-p vendor] file
rem      -a or -i activates auto (intelligent) sync
rem      -u same as -b 32
rem      -b 16, -b 32 or -b 64 sets the processor mode
rem      -h displays this text
rem      -r or -v displays the version number
rem      -e skips <bytes> bytes of header
rem      -k avoids disassembling <bytes> bytes from position <start>
rem      -p selects the preferred vendor instruction set (intel, amd, cyrix, idt)
 
endlocal
