;----------------------------------------------------------------------------
;	SOURCE:	FF.asm
;	AUTHOR:	Ian Taylor - chilliant.com
;	NOTES:	Flag Factory 16-bit COM bootstrap entry point
;----------------------------------------------------------------------------

bits 16

segment _TEXT public align=16 class=CODE
segment C_ETEXT public align=16 class=CODE
STARTDATA:
segment _DATA public align=1 class=DATA
segment CONST public align=1 class=CONST
segment _BSS public align=1 class=BSS

group CGROUP _TEXT C_ETEXT
group DGROUP _DATA CONST _BSS

global STARTUP
extern _FFcom
segment _TEXT
	resb 100h
STARTUP:
	fninit
	; Prepare the stack parameters for FFcom
	xor si, si
	push WORD [si+2Ch]
	push si
	push ds
	push si
	; We need to fixup DS/SS to use the correct segment (though same address)
	mov ax, STARTDATA
	mov bx, ax
	mov cl, 4
	shr ax, cl
	; Load DS with the segment of our DGROUP
	mov cx, cs
	add cx, ax
	mov ds, cx
	mov ss, cx
	sub sp, bx
	; Pass the PSP and environment addresses as parameters
	call _FFcom
	add sp, 8
	ret